program trace
!
  use mpi
!
  implicit none
  integer, dimension(MPI_STATUS_SIZE)  :: statut
  integer, parameter                   :: etiquette=300
  integer                              :: nb_processus, rang,num_proc_precedent, num_proc_suivant, code
  real*8, dimension (:,:), allocatable :: A 
  real*8                               :: traceloc, traceglob, alpha
  integer                              :: i, j, ng, nl1, nl2, nl, p, q
!
  call MPI_INIT (code)
  call MPI_COMM_SIZE (MPI_COMM_WORLD, nb_processus, code)
  call MPI_COMM_RANK (MPI_COMM_WORLD, rang, code)
!
  num_proc_precedent = mod(nb_processus+rang-1,nb_processus)
  num_proc_suivant = mod(rang+1,nb_processus)
!
  if (rang == 0) then
    print*,'donner la taille de la matrice globale'
    read*, ng
    print*,'donner la valeur de alpha'
    read*, alpha
  end if
!
  call MPI_BCAST (ng, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, code)
  call MPI_BCAST (alpha, 1, MPI_DOUBLE_PRECISION, 0, MPI_COMM_WORLD, code)
!
  nl1 = ng/nb_processus
  nl2 = ng - (nl1*(nb_processus-1))
  nl = nl1
  if (rang==nb_processus-1) nl = nl2
  p = 1+(nl1*rang)
  q = nl+(nl1*rang)
  allocate (A(p:q, p:q))
!
  do j = p, q
   do i = p, q
    A(i,j)=alpha*rang
   end do
  end do
!
  traceloc = 0.
  do i = p, q
   traceloc = traceloc + A(i,i)
  end do
  print *,'Moi, processus ',rang,', j''ai une sous matrice de taille ',nl,' et une trace locale egale a', traceloc
!
  call MPI_REDUCE (..........................)
!
  if (rang == 0) then
   print *,'Moi, processus ',rang,', je recupere la trace globale de la matrice egale a', traceglob
  end if
!
  deallocate (A)
!
  call MPI_FINALIZE (code)
!
end program trace
