!================
module mod_matvec
!================
!
!=====================
interface operator (*)
!=====================
!
        module procedure matvec
!
!============
end interface
!============
!
contains
!
!=====================
function matvec (A, v)
!=====================
!

        use mpi
        use mod_dataproc
!
        implicit none
!
        real(kind=8), dimension(:,:), intent(in) :: A
        real(kind=8), dimension(:), intent(in) :: v
        real(kind=8), dimension(size(v)) :: matvec
        integer :: n, i
        integer, dimension (MPI_STATUS_SIZE) :: statut
        real (kind = 8) :: west, est
!
        n = size(v)
!
! Produit matrice-vecteur generique aux noeuds interieurs
        matvec(1) = A(2,1)*v(1 ) + A(3,1)*v(2)
        do i = 2, n-1
        matvec(i) = A(1,i)*v(i-1) + A(2,i)*v(i) + A(3,i)*v(i+1)
        end do
        matvec(n) = A(1,n)*v(n-1) + A(2,n)*v(n)
!
        west = v(n)
        est = v(1)
!
! Echanges bloquants
!
        if (moi /= 0) then
          call MPI_SEND (....................................)
          call MPI_RECV (....................................)
          matvec(1) = .......................................
        end if
        if (moi /= nprocs-1) then
          call MPI_RECV (....................................)
          matvec(n) = .......................................
          call MPI_SEND (....................................)
        end if
!
!==================
end function matvec
!==================
!
!====================
end module mod_matvec
!====================
