!===============
program calculPI
!===============
!
! Appel aux modules

        use mpi
!
        implicit none
!
! Declaration des tableaux dynamiques
        real(kind=8) :: PIexact, PI, PIloc, s, h, x
        integer      :: code, moi, nprocs, n, i
!
! Initialisation de MPI
        call MPI_INIT (code)
        call MPI_COMM_RANK (MPI_COMM_WORLD, moi, code)
        call MPI_COMM_SIZE (MPI_COMM_WORLD, nprocs, code)
!
! Fonction a integrer
!
        if (moi == 0) then
          print*,'donner le nombre d"intervalles global n'
          read*,n
        end if
!
! Distribution des donnees par moi=0 sur tous les autres processus
        call MPI_BCAST (n, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, code)
!
! Pas de maillage sur le domaine global en espace
        h = 1.d0/n
!
        s = 0.d0
        do i = moi+1, n, nprocs
         x = h * (float(i) -0.5)
         s = s + f(x)
        end do
        PIloc = h * s
        call MPI_REDUCE (PIloc, PI, 1, MPI_DOUBLE_PRECISION, MPI_SUM, 0, MPI_COMM_WORLD, code)
        if (moi ==0) then
         PIexact = ACOS(-1.D0)
         print*,'je suis le processeur moi=',moi,' et la valeur de PI est egale a ',PI,''
         print*,'Erreur sur PI :',ABS(PI-PIexact),''
        end if
!
! Fin de MPI
        call MPI_FINALIZE (code)
!
        CONTAINS
        function f(a)
         implicit none
         real(kind=8), intent(in) :: a
         real(kind=8) :: f
           f = 4.D0 / (1.D0 + a**2)
        end function f
!
!===================
end program calculPI
!===================
